package com.abi.qms.platform;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.time.Instant;
import java.time.LocalDateTime;
import java.time.ZoneId;
import java.util.Calendar;
import java.util.Date;

/**
 * @author lu
 * @date 2021年06月09日 11:53
 */
public class Demo {
    private static final DateFormat DATE_FORMAT = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
    public static void main(String[] args) {
        Date now = new Date();
        System.out.println("当前日期：" + DATE_FORMAT.format(now));
        LocalDateTime newDate = stepMonth(now, -4);
        System.out.println(newDate+"======");
        System.out.println("当前时间前4个月的日期：" + DATE_FORMAT.format(newDate));
    }
    /**
     * 在给定的日期加上或减去指定月份后的日期
     *
     * @param sourceDate 原始时间
     * @param month      要调整的月份，向前为负数，向后为正数
     * @return
     */
    public static LocalDateTime stepMonth(Date sourceDate, int month) {
        Calendar c = Calendar.getInstance();
        c.setTime(sourceDate);
        c.add(Calendar.MONTH, month);
        Instant instant = c.getTime().toInstant();
        ZoneId zoneId = ZoneId.systemDefault();
        LocalDateTime localDateTime = instant.atZone(zoneId).toLocalDateTime();
        return localDateTime;
    }
}
